# debug

### **traceBlockByHash(id: `BlockHash`, params?: `TraceParams`): `Vec<TransactionTrace>`**

* **jsonrpc**: `debug_traceBlockByHash`
* **summary**: `traceBlockByHash` accepts a block hash and will replay the block that is already present in the database. For the second parameter, see the`TraceParams` reference.

### **traceBlockByNumber(id: `BlockNumber`, params?: `TraceParams`): `Vec<TransactionTrace>`**

* **jsonrpc**: `debug_traceBlockByNumber`
* **summary**: `traceBlockByNumber` accepts a block number and will replay the block that is already present in the database. For the second parameter, see the`TraceParams` reference.

### **traceTransaction(transaction\_hash: `hash`, params?: `TraceParams`): `TransactionTrace`**

* **jsonrpc**: `debug_traceTransaction`
* **summary**: The `traceTransaction`debugging method will attempt to run the transaction in the exact same manner as it was executed on the network. It will replay any transaction that may have been executed prior to the current one before it finally attempts to execute the transaction that corresponds to the given hash. For the second parameter, see the `TraceParams` reference.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bifrostnetwork.com/bifrost-network/developer-documentations/client-api/json-rpc-api/debug.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
